﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
    Private fm As FirebaseMessaging
    Public MyFCMToken As String
    Public ImHere As Timer
	Public FCM_KEY As String = "...."
	Public MessType, MessNickName, MessFCMToken,MessMessage, MessFrom As String
	
	Public ChatsMap As Map
	
	Public MyName As String ="Klaus12345"
	Public MyIp, MyNickname As String
	
	Public MySocket As ServerSocket
	
End Sub

Sub Service_Create
    fm.Initialize("fm")
	MyFCMToken=fm.Token
    Log (MyFCMToken)
	Subscribe
	ImHere.Initialize("ImHere",10000)
	ImHere.Enabled=True
	ChatsMap.Initialize
	
	MySocket.Initialize(0,"")
	MyIp=MySocket.GetMyWifiIP
	If MyIp.StartsWith("127") Then
		MyIp=MySocket.GetMyIP
	End If
	If MyIp.StartsWith("127") Then
		CallSubDelayed(Main,"NoInternet")
	End If
	
	MyNickname=MyName&"_"&MyIp
	Log(MyNickname)
	
End Sub

Public Sub Subscribe
    'you can subscribe to more topics
	fm.SubscribeToTopic("all")	
End Sub

Sub ImHere_Tick
	
	'CallSubDelayed3(Main,"NewMess","System","Sending NickName" & MyNickname)
	ImHere.Enabled=False
	
	Dim data As Map = CreateMap("MessType":"ImHere","NickName": MyNickname,"FCMToken": MyFCMToken)
	SendMessageToTopic("all", data)
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	If StartingIntent.IsInitialized And fm.HandleIntent(StartingIntent) Then Return

End Sub

Sub fm_MessageArrived (Message As RemoteMessage)
	'CallSubDelayed3(Main,"NewMess","System","Message arrived...")
    Log("Message arrived")
    Log($"Message data: ${Message.GetData}"$)
    Log("ID: " & Message.MessageId)
    Log("From: " & Message.From)
    Log("Collapse: " & Message.CollapseKey)
    Log(Message.GetData)
   
	Dim MessCompleteMap As Map
	MessCompleteMap=Message.GetData
	
	
	Dim parser As JSONParser
	parser.Initialize(MessCompleteMap.Get("data"))
	
	Dim DataMap As Map
	DataMap=parser.NextObject
	
	MessType=DataMap.Get("MessType")
	
	Select MessType
		Case "ImHere"
			MessNickName=DataMap.Get("NickName")
			MessFCMToken=DataMap.Get("FCMToken")
			
			If MessNickName<>MyNickname Then
				ChatsMap.Put(MessNickName,MessFCMToken)
			    Log("Received: " & MessNickName & "/" & MessFCMToken)
			End If
			
			CallSubDelayed(Main,"UpdateSpinner")
			
		Case "ChatMessage"
			MessFrom =DataMap.Get("From")
			MessMessage=DataMap.Get("Message")
			CallSubDelayed3(Main,"NewMess",MessFrom,MessMessage)
				
	End Select
	
End Sub

Sub JobDone(Job As HttpJob)
	
	If Job.Success Then
		Dim res As String
		res = Job.GetString
		Log("Back from Job:" & Job.JobName )
		Log("Response from server: " & res)
		
		Dim parser As JSONParser
		parser.Initialize(res)
				
		Select Job.JobName
				
			Case "SendMessageDev"
				
				If res.Contains($""success":1"$) Then
					Log("OK")
					CallSubDelayed3(Main,"NewMess","System","Message sent...")
				Else
					CallSubDelayed2(Main,"CriticalError",res)
					Log("Something went wrong...")
				End If
					
				
			Case "SendMessageTopic"
					
				If res.Contains("message_id") Then
					Log("OK")
				Else
					Log("Something went wrong...")
				End If
				
		End Select
	Else
		Log("Error: " & Job.ErrorMessage)
	End If
	Job.Release
	
	ImHere.Enabled=True
	
End Sub



Private Sub SendMessageToSingleDevice(FCMToken As String, datamap As Map)
  
	Dim Job As HttpJob
	Job.Initialize("SendMessageDev", Me)
   
	DateTime.DateFormat="dd.MM.yyyy"
	Dim DatumZeit As String
	DatumZeit=DateTime.Date(DateTime.Now)
	DatumZeit=DatumZeit & " " & DateTime.Time(DateTime.Now)
   
   
	Dim m As Map = CreateMap("to": $"${FCMToken}"$)
	Dim data As Map = CreateMap("data": datamap)
	m.Put("data", data)
	m.Put("content_available": True)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	Job.Tag=jg
	Log(jg.ToString)
	Job.PostString("https://fcm.googleapis.com/fcm/send", jg.ToString)
	Job.GetRequest.SetContentType("application/json;charset=UTF-8")
	Job.GetRequest.SetHeader("Authorization", "key=" & FCM_KEY)
   
End Sub
  
Private Sub SendMessageToTopic(Topic As String, datamap As Map)
  
	Dim Job As HttpJob
	Job.Initialize("SendMessageTopic", Me)
   
	Dim m As Map = CreateMap("to": $"/topics/${Topic}"$)
	Dim data As Map = CreateMap("data": datamap)
	m.Put("data", data)
	m.Put("content_available": True)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	Job.Tag=jg
	Log(jg.ToString)
	Job.PostString("https://fcm.googleapis.com/fcm/send", jg.ToString)
	Job.GetRequest.SetContentType("application/json;charset=UTF-8")
	Job.GetRequest.SetHeader("Authorization", "key=" & FCM_KEY)
   
End Sub


Sub Service_Destroy

End Sub